package assign04_JJL;

import gui.ClosableJFrame;

import java.io.Serializable;
import java.awt.image.BufferedImage;
import java.awt.*;

import j2d.ImageUtils;


/**
 * Created by IntelliJ IDEA.
 * User: John
 * Date: Sep 26, 2005
 * Time: 11:10:27 PM
 * To change this template use File | Settings | File Templates.
 */

final public class Assign04_JJL implements Serializable {
/*
Due : Oct 10, 2005:

Write a program that inputs a java.awt.Image and, using the PMF computed from
HW3, perform a UNAHE on the image.  How will [you] implement a LUT on a 24 bit 
image?  For each input color, there must be an output color.  That is:
       ColorOUt = lut(ColorIn);
This type of look up will have to be performed on a pixel-by-pixel basis
       
What kind of data structure will you use? Recall that there can be up 
to 16 million colors on input and these must be mapped to some output.



*/

    public static void displayOutput(BufferedImage bi, String s) {
        ClosableJFrame outFrame = new ClosableJFrame(s);
        Container c1 = outFrame.getContentPane();
        ImageUtils.ImagePanel ip = new ImageUtils.ImagePanel(bi);
        c1.add(ip); // add imagepanel
        outFrame.pack();
        outFrame.setVisible(true);
    }

    public static void displayOutput(Image image, String s) {
        ClosableJFrame outFrame = new ClosableJFrame(s);
        Container c1 = outFrame.getContentPane();
        ImageUtils.ImagePanel ip = new ImageUtils.ImagePanel(image);
        c1.add(ip); // add imagepanel
        outFrame.pack();
        outFrame.setVisible(true);
    }


    private static void processImage() {

        BufferedImage biIn;
        biIn = j2d.ImageUtils.getBufferedImage2(j2d.ImageUtils.getImage());

        displayOutput(biIn, "Input Image");

        biIn = j2d.ImageUtils.getBufferedImage2(biIn);
        int [][] plane = new int[biIn.getWidth()][biIn.getHeight()];
        int w = plane.length;
        int h = plane[0].length;
        for (int i = 0; i < w; i++) {
            for (int j = 0; j < h; j++) {
                plane[i][j] = biIn.getRGB(i, j);
            }
        }
        assign04_JJL.MyStatsA4 ms = new assign04_JJL.MyStatsA4();
        int [][] planeOut = new int[w][h];
        planeOut = ms.performUNAHE(plane);

        BufferedImage biOut = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);
        /* comvert each pixel of plane[][] to biOut */
        for (int i = 0; i < w; i++) {
            for (int j = 0; j < h; j++) {
                biOut.setRGB(i, j, planeOut[i][j]);
            }
        }
        displayOutput(biOut, "Output Image");
        ms.initStats(planeOut);    /* Recompute the stats to verify the processing */
        System.out.println(" process image");
    }

    public static void main
            (String[] args) {

        processImage();

    }
}
